type expr =
    Int_Literal of string                
	| String_Literal of string             	 
  | Id of string                           
  | Assign of string * expr              
	| IntAssign of string * expr
	| LinkAssign of string * expr * expr  
	| FormAssign of string * expr * expr 
	| InputAssign of string * expr * expr * expr 
	| ImageAssign of string * expr * expr * expr
	| Button of expr * expr 	
  | Invoke of string * expr list         
  | Noexpr                                

type stmt =
    Block of stmt list
  | Expr of expr                            
  | Return of expr                           	

type func_decl = {
	fname : string;                            
  formals : string list;                     
  locals : string list;                     
  body : stmt list;
}

type program = string list * func_decl list 
