{ open Parser }

rule token = parse
  [' ' '\t' '\r' '\n'] { token lexbuf }
| "/*"     { comment lexbuf }           
| '('      { LPAREN }
| ')'      { RPAREN }
| '{'      { LBRACE }
| '}'      { RBRACE }
| ';'      { SEMI }
| ','      { COMMA }
| '='      { ASSIGN }
| "int="   { INTASSIGN }
| "link="  { LINKASSIGN }
| "form="  { FORMASSIGN}
| "input=" { INPUTASSIGN }
| "image=" { IMAGEASSIGN }
| "button" { BUTTON }
| "return" { RETURN }
| "declare"    { DECLARE }
| ['0'-'9']+ as lxm { INT_LITERAL(lxm) }
| '"'[^'"']*'"' as lxm { STRING_LITERAL(lxm) }
| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9']* as lxm { ID(lxm) }
| eof { EOF }
| _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
  "*/" { token lexbuf }
| _    { comment lexbuf }
